org.apache.commons.math3.geometry.euclidean.threed

## Class PolyhedronsSet

- java.lang.Object
- - org.apache.commons.math3.geometry.partitioning.AbstractRegion<Euclidean3D,Euclidean2D>
  - - org.apache.commons.math3.geometry.euclidean.threed.PolyhedronsSet

- All Implemented Interfaces:
    Region<Euclidean3D>

      public class PolyhedronsSet
      extends AbstractRegion<Euclidean3D,Euclidean2D>

  This class represents a 3D region: a set of polyhedrons.
  Since:
    3.0
  Version:
    $Id: PolyhedronsSet.java 1244107 2012-02-14 16:17:55Z erans $

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.commons.math3.geometry.partitioning.Region

      `Region.Location`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PolyhedronsSet()` Build a polyhedrons set representing the whole real line.
    `PolyhedronsSet(BSPTree<Euclidean3D> tree)` Build a polyhedrons set from a BSP tree.
    `PolyhedronsSet(Collection<SubHyperplane<Euclidean3D>> boundary)` Build a polyhedrons set from a Boundary REPresentation (B-rep).
    `PolyhedronsSet(double xMin, double xMax, double yMin, double yMax, double zMin, double zMax)` Build a parallellepipedic box.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PolyhedronsSet` | `buildNew(BSPTree<Euclidean3D> tree)` Build a region using the instance as a prototype.
    `protected void` | `computeGeometricalProperties()` Compute some geometrical properties.
    `SubHyperplane<Euclidean3D>` | `firstIntersection(Vector3D point, Line line)` Get the first sub-hyperplane crossed by a semi-infinite line.
    `PolyhedronsSet` | `rotate(Vector3D center, Rotation rotation)` Rotate the region around the specified point.
    `PolyhedronsSet` | `translate(Vector3D translation)` Translate the region by the specified amount.

    - ### Methods inherited from class org.apache.commons.math3.geometry.partitioning.AbstractRegion

      `applyTransform, checkPoint, checkPoint, contains, copySelf, getBarycenter, getBoundarySize, getSize, getTree, intersection, isEmpty, isEmpty, setBarycenter, setSize, side`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PolyhedronsSet

          public PolyhedronsSet()

      Build a polyhedrons set representing the whole real line.

    - #### PolyhedronsSet

          public PolyhedronsSet(BSPTree<Euclidean3D> tree)

      Build a polyhedrons set from a BSP tree.

      The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`

      Parameters:
        `tree` - inside/outside BSP tree representing the region

    - #### PolyhedronsSet

          public PolyhedronsSet(Collection<SubHyperplane<Euclidean3D>> boundary)

      Build a polyhedrons set from a Boundary REPresentation (B-rep).

      The boundary is provided as a collection of `sub-hyperplanes`. Each sub-hyperplane has the interior part of the region on its minus side and the exterior on its plus side.

      The boundary elements can be in any order, and can form several non-connected sets (like for example polyhedrons with holes or a set of disjoint polyhedrons considered as a whole). In fact, the elements do not even need to be connected together (their topological connections are not used here). However, if the boundary does not really separate an inside open from an outside open (open having here its topological meaning), then subsequent calls to the `checkPoint` method will not be meaningful anymore.

      If the boundary is empty, the region will represent the whole space.

      Parameters:
        `boundary` - collection of boundary elements, as a collection of `SubHyperplane` objects

    - #### PolyhedronsSet

          public PolyhedronsSet(double xMin,
                        double xMax,
                        double yMin,
                        double yMax,
                        double zMin,
                        double zMax)

      Build a parallellepipedic box.
      Parameters:
        `xMin` - low bound along the x direction
        `xMax` - high bound along the x direction
        `yMin` - low bound along the y direction
        `yMax` - high bound along the y direction
        `zMin` - low bound along the z direction
        `zMax` - high bound along the z direction

  - ### Method Detail

    - #### buildNew

          public PolyhedronsSet buildNew(BSPTree<Euclidean3D> tree)

      Build a region using the instance as a prototype.

      This method allow to create new instances without knowing exactly the type of the region. It is an application of the prototype design pattern.

      The leaf nodes of the BSP tree must have a `Boolean` attribute representing the inside status of the corresponding cell (true for inside cells, false for outside cells). In order to avoid building too many small objects, it is recommended to use the predefined constants `Boolean.TRUE` and `Boolean.FALSE`. The tree also must have either null internal nodes or internal nodes representing the boundary as specified in the `getTree` method).

      Specified by:
        `buildNew` in interface `Region<Euclidean3D>`
      Specified by:
        `buildNew` in class `AbstractRegion<Euclidean3D,Euclidean2D>`
      Parameters:
        `tree` - inside/outside BSP tree representing the new region
      Returns:
        the built region

    - #### computeGeometricalProperties

          protected void computeGeometricalProperties()

      Compute some geometrical properties.

      The properties to compute are the barycenter and the size.

      Specified by:
        `computeGeometricalProperties` in class `AbstractRegion<Euclidean3D,Euclidean2D>`

    - #### firstIntersection

          public SubHyperplane<Euclidean3D> firstIntersection(Vector3D point,
                                                     Line line)

      Get the first sub-hyperplane crossed by a semi-infinite line.
      Parameters:
        `point` - start point of the part of the line considered
        `line` - line to consider (contains point)
      Returns:
        the first sub-hyperplaned crossed by the line after the given point, or null if the line does not intersect any sub-hyperplaned

    - #### rotate

          public PolyhedronsSet rotate(Vector3D center,
                              Rotation rotation)

      Rotate the region around the specified point.

      The instance is not modified, a new instance is created.

      Parameters:
        `center` - rotation center
        `rotation` - vectorial rotation operator
      Returns:
        a new instance representing the rotated region

    - #### translate

          public PolyhedronsSet translate(Vector3D translation)

      Translate the region by the specified amount.

      The instance is not modified, a new instance is created.

      Parameters:
        `translation` - translation to apply
      Returns:
        a new instance representing the translated region

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.